simpleSqlParser
===============

Javascript library to parse CRUD (Create Retrieve Update Delete) SQL queries.

## How to use

### From browser

Import the JS file in your page:

```html
<script src="simpleSqlParser.js"></script>
```

### From Node.js

Install the module from [npm](https://npmjs.org/package/simple-sql-parser) using `npm i simple-sql-parser --save`.

Import the JS module in your app:

```js
var simpleSqlParser = require('simple-sql-parser');
```

### Parse a query:

```js
var ast = simpleSqlParser.sql2ast('your SQL query');
console.log(ast);
```

### Create a query from AST:

```js
var query = simpleSqlParser.ast2sql(ast);
console.log(query);
```

*AST means Abstract Syntax Tree.*

## Examples

* See `example.html` (open brower's console)
* Have a look to the unit tests `tests/tests.js` to see what's possible

## Notes

simpleSqlParser only supports these queries:

* SELECT
* INSERT
* UPDATE
* DELETE

simpleSqlParser **is not a full SQL parser!**
It only support few SQL mechanisms and keywords.
Feel free to make a pull request/issue.

## How to install dev tools

If you want to contribute, please write tests and respect the coding style.

To install dev tools:

- install Node.js (http://nodejs.org/)
- install **grunt-cli** globally: `npm i -g grunt-cli`
- install dev dependencies: `npm i`
- use `grunt` to check your code!

## License

The MIT License (MIT)
Copyright (c) 2013 David Sferruzza
 
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

